#include "testApp.h"

void testApp::onEmptyBufferDone(void* args, COMPONENT_T* component)
{
	ofLogVerbose() << "onEmptyBufferDone";
}

//--------------------------------------------------------------
void testApp::setup(){
	ofBackground(255,255,0);
	ofSetLogLevel(OF_LOG_VERBOSE);
	//overlay.loadImage("DSC09320.jpg");
	bcm_host_init();
	
	if(OMX_Init() == OMX_ErrorNone)
	{
		ofLogVerbose() << "OMX_ErrorNone";
	}else {
		ofLogVerbose() << "!OMX_ErrorNone";
	}
	status = 0;
	buf = NULL;
	port_settings_changed = 0;
	first_packet = 1;
	dest = NULL;
	video_decode = NULL;
	video_scheduler = NULL;
	video_render = NULL;
	clock = NULL;
	
	data = NULL;
	data_len = 0;
	find_start_codes = 0;
	packet_size = 16<<10; 
	
	memset(list, 0, sizeof(list));
	memset(tunnel, 0, sizeof(tunnel));
	
	
	if((client = ilclient_init()) == NULL)
	{
		ofLogVerbose() << "err";
	}else {
		ofLogVerbose() << "ilclient_init";
	}

	
	string decodeName = "video_decode";
	int flags = (ILCLIENT_DISABLE_ALL_PORTS | ILCLIENT_ENABLE_INPUT_BUFFERS);
	
	int componentState =0;
	
	componentState = ilclient_create_component(client, &video_decode, (char*)decodeName.c_str(), (ILCLIENT_CREATE_FLAGS_T)flags);
	ofLogVerbose() << "video_decode componentState: " << componentState;
	list[0] = video_decode;
	
	string video_render_string = "video_render";
	componentState = ilclient_create_component(client, &video_render, (char*)video_render_string.c_str(), ILCLIENT_DISABLE_ALL_PORTS);
	ofLogVerbose() << "video_render componentState: " << componentState;
	list[1] = video_render;
	
	string clock_string = "clock";
	componentState = ilclient_create_component(client, &clock, (char*)clock_string.c_str(), ILCLIENT_DISABLE_ALL_PORTS);
	
	ofLogVerbose() << "clock componentState: " << componentState;
	list[2] = clock;
	
	memset(&cstate, 0, sizeof(cstate));
	cstate.nSize = sizeof(cstate);
	cstate.nVersion.nVersion = OMX_VERSION;
	cstate.eState = OMX_TIME_ClockStateWaitingForStartTime;
	cstate.nWaitMask = 1;
	if (OMX_SetParameter(ILC_GET_HANDLE(clock), OMX_IndexConfigTimeClockState, &cstate) != OMX_ErrorNone) {
		ofLogVerbose() << "passing";
	}
	ofLogVerbose() << "creating scheduler";
	
	string video_scheduler_string = "video_scheduler";
	componentState = ilclient_create_component(client, &video_scheduler, (char*)video_scheduler_string.c_str(), ILCLIENT_DISABLE_ALL_PORTS);
	
	ofLogVerbose() << "video_scheduler componentState: " << componentState;
	list[3] = video_scheduler;
	
	ofLogVerbose() << "set_tunnel start";
	set_tunnel(tunnel, video_decode, 131, video_scheduler, 10);
	set_tunnel(tunnel+1, video_scheduler, 11, video_render, 90);
	set_tunnel(tunnel+2, clock, 80, video_scheduler, 12);
	
	
	// setup clock tunnel first
	if (ilclient_setup_tunnel(tunnel + 2, 0, 0) != 0) {
		ofLogVerbose() << "ilclient_setup_tunnel";
	} else {
		ilclient_change_component_state(clock, OMX_StateExecuting);
	}
	
	ilclient_change_component_state(video_decode, OMX_StateIdle);
	
	memset(&format, 0, sizeof(OMX_VIDEO_PARAM_PORTFORMATTYPE));
	format.nSize = sizeof(OMX_VIDEO_PARAM_PORTFORMATTYPE);
	format.nVersion.nVersion = OMX_VERSION;
	format.nPortIndex = 130;
	format.eCompressionFormat = OMX_VIDEO_CodingAVC;
	
	bool  passed = false;
	bool formatSet = OMX_SetParameter(ILC_GET_HANDLE(video_decode), OMX_IndexParamVideoPortFormat, &format) == OMX_ErrorNone;
	ofLogVerbose() << "formatSet: " << formatSet;
	
	int portBuffersEnabled = ilclient_enable_port_buffers(video_decode, 130, NULL, NULL, NULL);
	ofLogVerbose() << "portBuffersEnabled: " << portBuffersEnabled;
	if ( formatSet && portBuffersEnabled == 0) 
	{
		ilclient_change_component_state(video_decode, OMX_StateExecuting);
		
		ilclient_set_empty_buffer_done_callback(client, onEmptyBufferDone, this);
		passed = true;
	} else {
		passed = false;
	}
	ofLogVerbose() << "passed" << passed;
	/*bool formatSet = OMX_SetParameter(ILC_GET_HANDLE(video_decode), OMX_IndexParamVideoPortFormat, &format) == OMX_ErrorNone;
	ofLogVerbose() << "formatSet: " << formatSet;
	
	
	int portBuffersEnabled = ilclient_enable_port_buffers(video_decode, 130, NULL, NULL, NULL);
	ofLogVerbose() << "portBuffersEnabled: " << portBuffersEnabled;*/
	
	string filenameString = ofToDataPath("test.h264", true);
	
	in = fopen(filenameString.c_str(), "rb");
	if (in == NULL) {
		ofLogVerbose() << filenameString << " open Failed";
	}else {
		ofLogVerbose() << filenameString << " opened";
	}
	isVideoReady = passed;
	
	if(passed)
	{
		int status = 0;
		OMX_BUFFERHEADERTYPE *buf;
		int port_settings_changed = 0;
		int first_packet = 1;
		
		int didChangeStateCode = ilclient_change_component_state(video_decode, OMX_StateExecuting);
		ofLogVerbose() << "didChangeStateCode: " << didChangeStateCode;
	}
		
				
		/*buf->nFilledLen = 0;
		buf->nFlags = OMX_BUFFERFLAG_TIME_UNKNOWN | OMX_BUFFERFLAG_EOS;
		
		if(OMX_EmptyThisBuffer(ILC_GET_HANDLE(video_decode), buf) != OMX_ErrorNone)
			status = -20;
		
		// wait for EOS from render
		ilclient_wait_for_event(video_render, OMX_EventBufferFlag, 90, 0, OMX_BUFFERFLAG_EOS, 0,
								ILCLIENT_BUFFER_FLAG_EOS, 10000);
		
		// need to flush the renderer to allow video_decode to disable its input port
		ilclient_flush_tunnels(tunnel, 0);
		
		ilclient_disable_port_buffers(video_decode, 130, NULL, NULL, NULL);*/
	//}
	
	
}

//--------------------------------------------------------------
void testApp::exit(){}

//--------------------------------------------------------------
void testApp::update(){
	//ofLogVerbose() << "UPDATING";

}

//--------------------------------------------------------------
void testApp::draw() {
	if (!isVideoReady) 
	{
		return;
	}
	buf = ilclient_get_input_buffer(video_decode, 130, 1);
	if(buf != NULL)
	{
		
		int timestamp = ilclient_ticks_to_s64(buf->nTimeStamp);
		
		// feed data and wait until we get port settings changed
		dest = find_start_codes ? data + data_len : buf->pBuffer;
		
		data_len += fread(dest, 1, packet_size+(find_start_codes*4)-data_len, in);
		ofLogVerbose() << "data_len: " << data_len;
		ofLogVerbose() << "timestamp: " << timestamp;
		if(port_settings_changed == 0 &&
		   ((data_len > 0 && ilclient_remove_event(video_decode, OMX_EventPortSettingsChanged, 131, 0, 0, 1) == 0) ||
			(data_len == 0 && ilclient_wait_for_event(video_decode, OMX_EventPortSettingsChanged, 131, 0, 0, 1,
													  ILCLIENT_EVENT_ERROR | ILCLIENT_PARAMETER_CHANGED, 10000) == 0)))
		{
			port_settings_changed = 1;
			
			if(ilclient_setup_tunnel(tunnel, 0, 0) != 0)
			{
				status = -7;
				return;
			}
			
			ilclient_change_component_state(video_scheduler, OMX_StateExecuting);
			
			// now setup tunnel to video_render
			if(ilclient_setup_tunnel(tunnel+1, 0, 1000) != 0)
			{
				status = -12;
				return;
			}
			
			ilclient_change_component_state(video_render, OMX_StateExecuting);
		}
		if(!data_len)
			return;
		
		if(find_start_codes)
		{
			int i, start = -1, len = 0;
			int max_len = data_len > packet_size ? packet_size : data_len;
			for(i=2; i<max_len; i++)
			{
				if(data[i-2] == 0 && data[i-1] == 0 && data[i] == 1)
				{
					len = 3;
					start = i-2;
					
					// check for 4 byte start code
					if(i > 2 && data[i-3] == 0)
					{
						len++;
						start--;
					}
					
					return;
				}
			}
			
			if(start == 0)
			{
				// start code is next, so just send that
				buf->nFilledLen = len;
			}
			else if(start == -1)
			{
				// no start codes seen, send the first block
				buf->nFilledLen = max_len;
			}
			else
			{
				// start code in the middle of the buffer, send up to the code
				buf->nFilledLen = start;
			}
			
			memcpy(buf->pBuffer, data, buf->nFilledLen);
			memmove(data, data + buf->nFilledLen, data_len - buf->nFilledLen);
			data_len -= buf->nFilledLen;
		}
		else
		{
			buf->nFilledLen = data_len;
			data_len = 0;
		}
		
		buf->nOffset = 0;
		if(first_packet)
		{
			buf->nFlags = OMX_BUFFERFLAG_STARTTIME;
			first_packet = 0;
		}
		else
			buf->nFlags = OMX_BUFFERFLAG_TIME_UNKNOWN;
		
		if(OMX_EmptyThisBuffer(ILC_GET_HANDLE(video_decode), buf) != OMX_ErrorNone)
		{
			status = -6;
			return;
		}
		
	}
	//overlay.draw(0, 0);
}

//--------------------------------------------------------------
void testApp::keyPressed(int key){}

//--------------------------------------------------------------
void testApp::keyReleased(int key){}

//--------------------------------------------------------------
void testApp::mouseMoved(int x, int y ){}

//--------------------------------------------------------------
void testApp::mouseDragged(int x, int y, int button){}

//--------------------------------------------------------------
void testApp::mousePressed(int x, int y, int button){}

//--------------------------------------------------------------
void testApp::mouseReleased(int x, int y, int button){}

//--------------------------------------------------------------
void testApp::windowResized(int w, int h){}

//--------------------------------------------------------------
void testApp::gotMessage(ofMessage msg){}

//--------------------------------------------------------------
void testApp::dragEvent(ofDragInfo dragInfo){}
